<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-backtrace/types/src/when_postcard.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>when_postcard.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_backtrace_types/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_backtrace_types/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_backtrace_types/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">postcard::ser_flavors::Flavor</span>;
<span class="kw">use</span> <span class="ident">serde::Serialize</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">Entry</span>, <span class="ident">Postamble</span>, <span class="ident">Preamble</span>};

<span class="kw">struct</span> <span class="ident">LameFlavor</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="ident">send_byte</span>: <span class="ident">F</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> <span class="ident">LameFlavor</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">send_byte</span>: <span class="ident">F</span>) -&gt; <span class="self">Self</span> {
        <span class="self">Self</span> { <span class="ident">send_byte</span> }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">E</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span> <span class="ident">Flavor</span> <span class="kw">for</span> <span class="kw-2">&amp;mut</span> <span class="ident">LameFlavor</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Output</span> <span class="op">=</span> ();

    <span class="kw">fn</span> <span class="ident">try_push</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="ident">u8</span>) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        (<span class="self">self</span>.<span class="ident">send_byte</span>)(<span class="ident">data</span>).<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">postcard::Error::SerdeSerCustom</span>)
    }

    <span class="kw">fn</span> <span class="ident">finalize</span>(<span class="self">self</span>) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Output</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Serialize</span><span class="op">&gt;</span> <span class="ident">Preamble</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">send</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">E</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">send_byte</span>: <span class="ident">F</span>) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="ident">postcard::serialize_with_flavor</span>(<span class="self">self</span>, <span class="kw-2">&amp;mut</span> <span class="ident">LameFlavor::new</span>(<span class="ident">send_byte</span>))
    }
}

<span class="kw">impl</span> <span class="ident">Entry</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">send</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">E</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">send_byte</span>: <span class="ident">F</span>) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">flavor</span> <span class="op">=</span> <span class="ident">LameFlavor::new</span>(<span class="ident">send_byte</span>);
        <span class="ident">postcard::serialize_with_flavor</span>(<span class="kw-2">&amp;</span><span class="bool-val">true</span>, <span class="kw-2">&amp;mut</span> <span class="ident">flavor</span>)<span class="question-mark">?</span>;
        <span class="ident">postcard::serialize_with_flavor</span>(<span class="self">self</span>, <span class="kw-2">&amp;mut</span> <span class="ident">flavor</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span> <span class="ident">Postamble</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">send</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">E</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">send_byte</span>: <span class="ident">F</span>) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">flavor</span> <span class="op">=</span> <span class="ident">LameFlavor::new</span>(<span class="ident">send_byte</span>);
        <span class="ident">postcard::serialize_with_flavor</span>(<span class="kw-2">&amp;</span><span class="bool-val">false</span>, <span class="kw-2">&amp;mut</span> <span class="ident">flavor</span>)<span class="question-mark">?</span>;
        <span class="ident">postcard::serialize_with_flavor</span>(<span class="self">self</span>, <span class="kw-2">&amp;mut</span> <span class="ident">flavor</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_backtrace_types" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>